import java.io.*;

import static java.lang.Math.*;

public class MaartenBufferedReader {
    public static void main(String[] args) throws IOException {
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(System.in))) {
            new MaartenBufferedReader().run(reader);
        }
    }

    // (n, x), amps = map(int, input().split()), list(map(float, input().split()))
    // orig_x = sum(a * a for a in amps)
    // print(" ".join(str(0 if x == 0 or orig_x == 0 else a * sqrt(n*x) / sqrt(orig_x)) for a in amps))
    public void run(BufferedReader reader) throws IOException {
        String[] firstLine = reader.readLine().split(" ");
        int n = Integer.parseInt(firstLine[0]);
        long x = Long.parseLong(firstLine[1]);

        long[] amps = new long[n];
        long orig_x = 0;
        int i = 0;
        for (String a : reader.readLine().split(" ")) {
            long ai = Long.parseLong(a);
            amps[i++] = ai;
            orig_x += ai * ai;
        }

        if (x == 0 || orig_x == 0) {
            for (int j = 0; j < n; j++) {
                System.out.println(0);
            }
        } else {
            for (long a : amps) {
                System.out.println(a * sqrt(n * x) / sqrt(orig_x));
            }
        }
    }
}
