import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class MaartenScanner {
    public static void main(String[] args) throws IOException {
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(System.in))) {
            new MaartenScanner().run(new Scanner(reader));
        }
    }

    public void run(Scanner sc) throws IOException {
        int n = sc.nextInt();
        long x = sc.nextLong();

        long[] amps = new long[n];
        long orig_x = 0;
        for (int i = 0; i < n; i++) {
            long ai = sc.nextLong();
            amps[i] = ai;
            orig_x += ai * ai;
        }

        if (x == 0 || orig_x == 0) {
            for (int j = 0; j < n; j++) {
                System.out.println(0);
            }
        } else {
            for (long a : amps) {
                System.out.println(a * sqrt(n * x) / sqrt(orig_x));
            }
        }
    }
}
