import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class MaartenScannerDouble {
    public static void main(String[] args) throws IOException {
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(System.in))) {
            new MaartenScannerDouble().run(new Scanner(reader));
        }
    }

    public void run(Scanner sc) throws IOException {
        int n = sc.nextInt();
        double x = sc.nextDouble();

        double[] amps = new double[n];
        double orig_x = 0;
        for (int i = 0; i < n; i++) {
            double ai = sc.nextDouble();
            amps[i] = ai;
            orig_x += ai * ai;
        }

        if (x == 0 || orig_x == 0) {
            for (int j = 0; j < n; j++) {
                System.out.println(0);
            }
        } else {
            for (double a : amps) {
                System.out.println(a * sqrt(n * x) / sqrt(orig_x));
            }
        }
    }
}
