#!/usr/bin/env python3
# @EXPECTED_RESULTS@: ACCEPTED,WRONG_ANSWER
from collections import defaultdict
import math

n = int(input())

G = defaultdict(list)

BOXSIZE = 10 ** 8
for _ in range(n):
    x, y, z = [int(x) for x in input().split()]
    G[(x // BOXSIZE, y // BOXSIZE, z // BOXSIZE)].append((x, y, z))


def dist(elt1, elt2):
    A = 0
    for a, b in zip(elt1, elt2):
        A += (a - b) * (a - b)
    return math.sqrt(A)


ans = 2 ** 63
for box in G.values():
    for elt1 in box:
        for elt2 in box:
            if elt1 != elt2:
                ans = min(ans, dist(elt1, elt2))

print(ans)
