#!/usr/bin/env python3
from collections import Counter


def is_subseq(x, y):
    it = iter(y)
    return all(c in it for c in x)


n, weight_per_bucket = map(int, input().split())
ws = list(map(int, input().split()))

hammers = sum(w // weight_per_bucket - (w % weight_per_bucket == 0) for w in ws)
stones_left = Counter([w % weight_per_bucket for w in ws if w % weight_per_bucket != 0])

# print(stones_left, file=sys.stderr)

splits_of_size = [set(), {(1,)}]
for size in range(2, weight_per_bucket * (weight_per_bucket - 1) + 1):
    splits = set()
    for i in range(1, min(weight_per_bucket, size + 1)):
        if size == i:
            splits.add((i,))
        else:
            [splits.add(tuple(sorted((i, *s), reverse=True))) for s in splits_of_size[size - i]]
    splits_of_size.append(splits)
    # TODO: as speedup, splits_of_size[8,16,24,...] should only contain tuples that cannot be split with lower round splits
    # round_split = splits_of_size[(size - 1) // weight_per_bucket * weight_per_bucket]
    # splits_of_size.append({s for s in splits if not (round_split and is_subseq(round_split, s))})

# print({i: len(s) for i, s in enumerate(splits_of_size)}, file=sys.stderr)
# print(len({tuple(sorted((*a, *b), reverse=True)) for a in splits_of_size[8] for b in splits_of_size[8]}), file=sys.stderr)

# print(sorted(splits_of_size[weight_per_bucket * 2], reverse=True), file=sys.stderr)
# print(sorted({tuple(sorted((*a, *b), reverse=True)) for a in splits_of_size[8] for b in splits_of_size[8]}, reverse=True), file=sys.stderr)

saved1, saved2, saved1a, saved1b = 0, 0, 0, 0
for size in range(weight_per_bucket, weight_per_bucket ** 2, weight_per_bucket):
    for splits in sorted(splits_of_size[size], reverse=True):
        counter = Counter(splits)
        m = min(stones_left[k] // v for k, v in counter.items())
        if weight_per_bucket == 6 and counter == {2: 3} or \
                weight_per_bucket == 7 and splits == (5, 1, 1) or \
                weight_per_bucket == 8 and (splits == (4, 2, 2) or splits == (3, 3, 2) or counter == {3: 3, 7: 1}):
            saved1 += m
        if weight_per_bucket == 7 and splits == (4, 3) or weight_per_bucket == 8 and splits == (4, 2, 2):
            saved1a += m
        if weight_per_bucket == 8 and splits == (6, 1, 1): saved1b += m
        if weight_per_bucket == 8 and counter == {2: 4}: saved2 += m
        if m:
            for k, v in counter.items(): stones_left[k] -= m * v
            hammers += m * (size // weight_per_bucket - 1)
            if weight_per_bucket == 6 and counter == {5: 6} or \
                    weight_per_bucket == 7 and counter == {3: 7} or \
                    weight_per_bucket == 8 and counter == {7: 8}:
                hammers -= min(m, saved2) * 2 + min(max(0, m - saved2), saved1)
            if weight_per_bucket == 7 and counter == {5: 7} or \
                    weight_per_bucket == 8 and (counter == {3: 8} or counter == {7: 5, 5: 1}):
                hammers -= min(m, saved1a)
            if weight_per_bucket == 8 and counter == {5: 8}: hammers -= min(m, saved1b)
            # print(m, size, weight_per_bucket, counter, hammers, "saved", saved1, saved2, saved1a, saved1b, file=sys.stderr)
    if not any(stones_left.values()): break

print(hammers)
